<?php
/*
 * @package Include/help/ja
 */
?>

<h1>イベントアラート</h1>

イベントにアラートを設定することができます。これによりより柔軟なアプローチを実現します。これは、Enterprise 版の機能です。

新たなイベントアラートを作成するには、システム管理メニューのイベントアラートメニューで作成ボタンをクリックします。 <br><br>

<br><br>

<?php html_print_image('images/help/event01.png', false, ['width' => '250px']); ?>

<br>
イベントアラートは、論理式(and、or、xor、nand、nor、nxor)で結合されたルールで組
み立てられます。
<br><br>

<?php html_print_image('images/help/event02.png', false, ['width' => '550px']); ?>

<br>
簡単に言うと、イベントアラートの設定パラメータは、モジュールアラートと同じです。イベントアラート特有のパラメータは2つだけです。
<br><br>
    <b>ルール評価モード: </b> drop モードでは、一つのルールが満たされなければ、残りのアラートルールは評価されません。pass モードでは、残りのルールも評価されます。  
<br><br>
    <b>グループごと:</b> エージェント、モジュール、アラート、またはグループによって、ルールをグループ化します。例えば、2つの障害イベントを受け取ったときに、通知するようなルールが設定されていてエージェントでグループ化されていた場合は、同じエージェントから 2つの障害イベントが届きます。これは off にすることができます。  
<br><br>
それぞれのルールは、特定の種類のイベントで通知されるように設定されます。アラートは、ルールで定義された論理式および条件を満たした場合に通知されます。
<br><br>


<?php html_print_image('images/help/event03.png', false, ['width' => '550px']); ?>

<br>

一つのルールの設定パラメータは次の通りです。 
<br><br>
    <b>名前(Name)</b> ルール名。<br>
    <b>ユーザコメント(User comment):</b> 任意のコメント。<br>
    <b>イベント(Event):</b> イベントテキストにマッチする正規表現。<br>
    <b>ウインドウ(Window): </b>イベントの生成時間範囲。この時間範囲外のイベントは拒否されます。* <br>
    <b>回数(Count):</b> ルールにマッチし通知されるイベントの数。 <br>
    <b>エージェント(Agent): </b>イベントを生成したエージェント名にマッチする正規表現。<br>
    <b>モジュール(Module):</b>  イベントを生成したモジュール名にマッチする正規表現。 <br>
    <b>モジュールアラート(Module alerts):</b> イベントを生成したアラート名にマッチする正規表現。 <br>
    <b>グループ(Group): </b>エージェントが属するグループ。 <br>
    <b>重要度(Criticity):</b> イベントの重要度。 <br>
    <b>タグ(Tag):</b> イベントに関連づけられたタグ。 <br>
    <b>ユーザ(User):</b> イベントに関連づけられたユーザ。 <br>
    <b>イベントタイプ(Event type):</b> イベントの種類。  <br><br>

例えば、System タグに関連づけられたサーバグループの任意のエージェントの cpu_load という名前の任意のモジュールが障害状態になったときに、生成されたイベントにマッチするルールを設定できます。 
<br><br>


<?php html_print_image('images/help/event04.png', false, ['width' => '550px']); ?>


<p>* <?php echo get_product_name(); ?> データベースに保存できるイベント数に関しては、pandora_server.conf ファイルの event_window パラメータにて定義します。この時間範囲を越えるイベントが発生した場合は、サーバは処理を行いません。そのため、サーバの設定よりも大きな時間間隔を設定しても意味がありません。 </p>

